<template lang="pug">

.admin-body(
  :class="appClass"
  v-if="$store.state.adminAuth")

  app-header

  app-menu(
    :collapsMenu="collapsMenu")

  nuxt

</template>

<script>
import MenuBlock from '../components/admin/MenuBlock.vue';
import Header from '../components/admin/Header.vue';

import { mapGetters, mapMutations } from 'vuex';
import * as Cookies from 'js-cookie';

export default {
  name: 'Admin',
  components: {
    'app-menu': MenuBlock,
    'app-header': Header
  },
  head() {
    return {
      title: 'Административная панель | АО «Шувалово»'
    };
  },
  data() {
    return {
      headingTitle: '',
      pages: [],
      appClass: 'menu-expand',
      collapsMenu: false,
      userExit: false,
      menuStyle: 'none',
      noViewInLogin: true
    };
  },
  computed: {
    ...mapGetters({
      user: 'USER'
    })
  },
  created() {
    if (Cookies.get('__a_t')) {
      this.$axios
        .post('/api/v1/authFromToken', {
          access_token: Cookies.get('__a_t') || '',
          refresh_token: Cookies.get('__r_t') || ''
        })
        .then(data => {
          if (data.status === 200 && data.data.role === 'admin') {
            this.$store.commit('userAuth', true);
            this.$store.commit('adminAuth', true);
            this.$store.commit('user', data.data);
            this.$route.path !== '/admin/login'
              ? this.$router.push(location.pathname)
              : this.$router.push('/admin');
          } else {
            this.$router.push('/admin/login');
            this.$store.commit('adminAuth', false);
            Cookies.remove('__a_t');
            Cookies.remove('__r_t');
          }
        })
        .catch(() => {
          this.$store.commit('adminAuth', false);
          this.$router.push('/admin/login');
          Cookies.remove('__a_t');
          Cookies.remove('__r_t');
        });
    } else {
      this.$store.commit('adminAuth', false);
      this.$router.push('/admin/login');
      Cookies.remove('__a_t');
      Cookies.remove('__r_t');
    }
  },
  mounted() {
    this.$axios.setHeader('Cookies', document.cookie);
    this.$nextTick(() => {
      window.addEventListener('resize', this.getWindowWidth);
    });
    this.getWindowWidth();
    this.checkCoockie();
  },
  methods: {
    ...mapMutations(['userAuth']),
    checkCoockie() {
      if (
        typeof Cookies.get('__r_t') !== 'undefined' &&
        atob(Cookies.get('__r_t'))
      ) {
        let coockeisExpires = atob(Cookies.get('__r_t')).split('|')[1];
        if (coockeisExpires < this.$moment().valueOf()) {
          Cookies.remove('__a_t');
          Cookies.remove('__r_t');
          this.$store.commit('userAuth', false);
          this.$store.commit('adminAuth', false);
          this.$router.push('/admin/login');
        }
      } else {
        Cookies.remove('__a_t');
        Cookies.remove('__r_t');
        this.$store.commit('userAuth', false);
        this.$store.commit('adminAuth', false);
        this.$router.push('/admin/login');
      }
    },
    removeCoockie() {
      Cookies.remove('__a_t');
      Cookies.remove('__r_t');
      this.$store.commit('userAuth', false);
      this.$store.commit('adminAuth', false);
      this.$router.push('/admin/login');
    },
    getWindowWidth() {
      if (
        this.$parent.$currentViewport.label === 'desktop-large' ||
        this.$parent.$currentViewport.label === 'hd-desktop'
      ) {
        this.appClass = 'menu-expand';
        this.collapsMenu = false;
      } else {
        this.appClass = 'menu-collaps';
        this.collapsMenu = true;
      }
    }
  }
};
</script>
